/* 쌠 (C) 2006-2015 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
/*! \file ********************************************************************
*
* Atmel Corporation
*
* - ̧		: Self_programming.c
* - ߲		: avr-gcc
*
* - x޲	: ް۰ގxS޲
*
* - pLq	: AVR106 - ׯ ؓǂݏpC֐
*
* - 		: {̧ق"۸ݸ"@\޲ׯ ؂̗eՂȓ
*				  ݏp֐܂݂܂BgpҊ֐͎̒ʂłB
*
*				  ReadFlashByte()
*				  ReadFlashPage()
*				  WriteFlashByte()
*				  WriteFlashPage()
*				  RecoverFlash()
*
*				  {̧قɊ܂܂c̊֐͏ňꗗ֐ɂĎgp
*				  ܂B
*
****************************************************************************/
#include <avr/io.h>
#include <avr/eeprom.h>
#include <avr/interrupt.h>
#include "Self_programming.h"
#include "flash.h"
void FillBuffer(unsigned char *dataPage);

/* I񂾊֐ްė̈ɔzu邽߂̑` */
#define BOOTLOADER_SECTION __attribute__ ((section (".bootloader")))

/*
* ׯ񕜋AEEPROM̑S̍\̕ϐ錾B
* FlashBackuppageNumberް񕜂ׂKv̏ꍇɏׂׯ
* ɏՕްׯ ߰ ڽ(/PAGESIZE)ێ܂B
* FlashBackup.statusް񕜂ׂKv邩m点܂B
*/
#ifdef __FLASH_RECOVER
EEMEM struct
{
	unsigned int  pageNumber;
	unsigned char status;
}FlashBackup = {0};
#endif

/*
* ̊֐ucFlashStartAdrɂė^ꂽׯ ڽɔzuꂽ1޲ĂԂ܂B
*/
unsigned char ReadFlashByte(MyAddressType flashStartAdr)
{
	return (unsigned char)*((MyFlashCharPointer)flashStartAdr);
} // ׯްԂB

/*!
* ̊֐flashStartAdr1ׯ ߰ނǂ݁AdataPage[]zްۑ܂B
* ۑ޲Đׯ ߰ޗeʂɈˑ܂B
* ֐͓ͱڽׯ ߰ ڽłȂꍇɋU(FALSE)AȊO͐^(TRUE)Ԃ܂B
**/
unsigned char ReadFlashPage(MyAddressType flashStartAdr, unsigned char *dataPage)
{
	unsigned int index;
	if(!(flashStartAdr & (PAGESIZE-1)))		// ͱڽ߰ ڽȂA
	{
		for(index = 0; index < PAGESIZE; index++)
		{
			dataPage[index] = ReadFlashByte(flashStartAdr + index);
		}
		return TRUE;						// L߰ ڽȂA^(TRUE)Ԃ܂B
	}
	else
	{
		return FALSE;						// ߰ ڽȂAU(FALSE)Ԃ܂B
	}
}

/*!
* ̊֐flashAddrׯ ڽ޲ ް܂B
* ͱڽ݂ɊւĖ׼ ޲ ڽȂU(FALSE)AȊO͐^(TRUE)Ԃ܂B
**/

unsigned char WriteFlashByte(MyAddressType flashAddr, unsigned char data)
{
	MyAddressType  pageAdr;
	unsigned char eepromInterruptSettings;
	if( AddressCheck( flashAddr & ~(PAGESIZE-1) ))
	{
		eepromInterruptSettings= EECR & (1<<EERIE);	// EEPROM荞݋Ԃꎞۑ
		EECR &= ~(1<<EERIE);						// EEPROM荞݋֎~
		while(EECR & (1<<EEPROM_program_enable));	// EEPROMݎsȂA܂őҋ@

		pageAdr=flashAddr & ~(PAGESIZE-1);			 // ޲ ڽׯ ߰ ڽ擾

		#ifdef __FLASH_RECOVER
		FlashBackup.status=0;						 // ׯɏՕ݂Ɋւް܂܂ȂƂB
		while(EECR & (1<<EEPROM_program_enable));
		LpmReplaceSpm(flashAddr, data);				// ׯ݊ɏՕeݒ
		WriteBufToFlash(ADR_FLASH_BUFFER);			// ׯ񕜊ɏՕɏ
		FlashBackup.pageNumber = (unsigned int) (pageAdr/PAGESIZE);	// ްׂ߰ ڽۑ
		FlashBackup.status = FLASH_BUFFER_FULL_ID;	// ׯ񕜊ɏՕް܂ނƂB

		while(EECR & (1<<EEPROM_program_enable));
		#endif
		LpmReplaceSpm(flashAddr, data);				// ׯ݊ɏՕeݒ
		WriteBufToFlash(pageAdr);					// ׯɏ

		#ifdef __FLASH_RECOVER
		FlashBackup.status = 0;						// ׯ񕜊ɏՕް܂܂ȂƂB

		while(EECR & (1<<EEPROM_program_enable));
		#endif

		EECR |= eepromInterruptSettings;			// EEPROM荞݋Ԃ𕜋A
		return TRUE;								// ^(TRUE)ŕA
	}
	else
	return FALSE;									// U(FALSE)ŕA
}

/*
* ̊֐flashStartAdrׯ ߰ ڽdataPage[]z񂩂ް܂B
* ޲Đׯ ߰ޗeʂɈˑ܂B
* flashStartAdrׯ ߰ ڽ̏ꍇɋU(FALSE)AȊO͐^(TRUE)Ԃ܂B
*/


unsigned char WriteFlashPage(MyAddressType flashStartAdr, unsigned char *dataPage)
{
	unsigned char eepromInterruptSettings;
	if( AddressCheck(flashStartAdr) )
	{
		eepromInterruptSettings = EECR & (1<<EERIE);	// EEPROM荞݋Ԃꎞۑ
		EECR &= ~(1<<EERIE);							// EEPROM荞݋֎~
		while(EECR & (1<<EEPROM_program_enable));		// EEPROMݎsȂA܂őҋ@

		#ifdef __FLASH_RECOVER
		FlashBackup.status=0;							// ׯɏՕ݂Ɋւް܂܂ȂƂB
		while(EECR & (1<<EEPROM_program_enable));
		FillBuffer(dataPage);							// ׯ݊ɏՕeݒ
		WriteBufToFlash(ADR_FLASH_BUFFER);				// ׯޯ̧ɏ
		FlashBackup.pageNumber=(unsigned int)(flashStartAdr/PAGESIZE);
		FlashBackup.status = FLASH_BUFFER_FULL_ID;		// ׯ񕜊ɏՕް܂ނƂB
		while(EECR & (1<<EEPROM_program_enable));
		#endif
		FillBuffer(dataPage);							// ׯ݊ɏՕeݒ
		WriteBufToFlash(flashStartAdr);					// ׯɏ
		#ifdef __FLASH_RECOVER
		FlashBackup.status=0;							// ׯɏՕ݂Ɋւް܂܂ȂƂB
		while(EECR & (1<<EEPROM_program_enable));
		#endif

		EECR |= eepromInterruptSettings;				// EEPROM荞݋Ԃ𕜋A
		return TRUE;									// ^(TRUE)ŕA
	}
	else
	return FALSE;										// U(FALSE)ŕA
}

/*
* ̊֐ׯɏՕׂKvް܂ނǂFlashBackup.statusS̕ϐ𒲂ׂ܂B
* ׯ񕜊ɏՕްFLASH_recovery.pageAdrɂė^ꂽׯ ߰ ڽɏ܂B
* ̊֐ׯ񕜔CӑI̏ꍇ۸т̎nŌĂ΂Ȃ΂Ȃ܂B
*/

unsigned char RecoverFlash() BOOTLOADER_SECTION;
unsigned char RecoverFlash()
{
	#ifdef __FLASH_RECOVER
	unsigned int index;
	if(FlashBackup.status == FLASH_BUFFER_FULL_ID)	// ׯޯ̧ް܂ނ
	{
		for(index=0; index < PAGESIZE; index+=2){	// ׯ݊ɏՕɏ
		_FILL_TEMP_WORD( index, *((MyFlashIntPointer)(ADR_FLASH_BUFFER+index)) );
	}
	WriteBufToFlash((MyAddressType)FlashBackup.pageNumber * PAGESIZE);
	FlashBackup.status=0;							// ׯɏՕ݂Ɋւް܂܂ȂƂB
	while(EECR & (1<<EEPROM_program_enable));
	return TRUE;									// 񕜂sꂽꍇɐ^(TRUE)Ԃ܂B
	}
	#endif
	return FALSE;
}

/*
* ̊֐͓͈ݗp̗Lׯ ߰ ڽ𒲂ׂ܂B
* ̏ꍇɂ^(TRUE)Ԃ܂B
* - ڽׯ ߰ނ̐擪w܂B
* - ڽSelf_programming.hŒ`͈͓łB
* - ڽׯ񕜊֐(Ȃ)ɂĊɏՕɎgp߰ ڽƈقȂ܂B
* ȊO͋U8FALSE)Ԃ܂B
*/
unsigned char AddressCheck(MyAddressType flashAdr)
{
	#ifdef __FLASH_RECOVER
	// sADR_LIMIT_LOW0̏ꍇɌx'pointless comparison with zero'^܂B𖳎
	if( (flashAdr >= ADR_LIMIT_LOW) && (flashAdr <= ADR_LIMIT_HIGH) &&
	(flashAdr != ADR_FLASH_BUFFER) && !(flashAdr & (PAGESIZE-1)) )
		return TRUE;						// ڽ͗L߰ ڽ
	else
		return FALSE;						// ڽ͖߰ ڽ
	#else
	if((flashAdr >= ADR_LIMIT_LOW) && (flashAdr <= ADR_LIMIT_HIGH) && !(flashAdr & (PAGESIZE-1) ) )
		return TRUE;						// ڽ͗L߰ ڽ
	else
		return FALSE;						// ڽ͖߰ ڽ
	#endif
}

/*
* ̊֐͓͈ɂė^ꂽׯ ߰ ڽׯꎞɏՕe܂B
*/

void WriteBufToFlash(MyAddressType flashStartAdr) BOOTLOADER_SECTION;
void WriteBufToFlash(MyAddressType flashStartAdr)
{
	#ifdef __HAS_RAMPZ__
	RAMPZ = (unsigned char)(flashStartAdr >> 16);
	#endif
	_PAGE_ERASE(flashStartAdr);
	while( SPMControllRegister & (1<<SPMEN) );	// ׯ݊܂őҋ@
	_PAGE_WRITE(flashStartAdr);
	while( SPMControllRegister & (1<<SPMEN) );	// ׯ݊܂őҋ@
	#ifdef RWWSRE
	_ENABLE_RWW_SECTION();						// RWẄċ
	#endif
}

/*
* ̊֐flashAddrŗ^ꂽׯ ߰ނǂ݁AflashAddrŗ^ꂽ1޲ĂްŒuAׯꎞɏՕ߰ޑŜۑ܂B
*/

void LpmReplaceSpm(MyAddressType flashAddr, unsigned char data) BOOTLOADER_SECTION;
void LpmReplaceSpm(MyAddressType flashAddr, unsigned char data)
{
	unsigned int index, oddByte, pcWord;
	MyAddressType  pageAdr;
	oddByte=(unsigned char)flashAddr & 1;
	pcWord=(unsigned int)flashAddr & (PAGESIZE-2);	// ߰ޓŏIް ޲Ĉʒu(ׯꎞɏՕ݂Ŏgp)
	pageAdr=flashAddr & ~(PAGESIZE-1);				// ޲ ڽׯ ߰ ڽ擾
	for(index=0; index < PAGESIZE; index+=2)
	{
		if(index==pcWord)
		{
			if(oddByte)
			{
				_FILL_TEMP_WORD( index, (*(MyFlashCharPointer)(flashAddr & ~1) | 
				((unsigned int)data<<8)));
			} // ׯꎞޯ̧Ɋ޲ď
			else
			{
				_FILL_TEMP_WORD( index, ( (*( (MyFlashCharPointer)flashAddr+1)<<8)  | data ) );
			} // ׯꎞޯ̧ɋ޲ď
		}
		else
		{
			_FILL_TEMP_WORD(index, *( (MyFlashIntPointer)(pageAdr+index) ) );
		} // ׯꎞޯ̧ɒׯꏑ
	}
}

/*
* ̊֐͈ꎞɏՕްŖ܂B
*/
void FillBuffer(unsigned char *dataPage) BOOTLOADER_SECTION;
void FillBuffer(unsigned char *dataPage)
{
	unsigned int index;
	for(index = 0; index < PAGESIZE; index+=2){		// ׯ݊ɏՕ𖞂B
		_FILL_TEMP_WORD(index, (unsigned int)dataPage[index]+((unsigned int)dataPage[index+1] << 8));
	}
}
